package com.njyunzhi.invoice.config.cros;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.web.servlet.config.annotation.CorsRegistration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import java.util.List;

@SpringBootConfiguration
public class CorsConfig implements WebMvcConfigurer {

    @Autowired
    CorsProperties crosProperties;

    @Override
    public void addCorsMappings(CorsRegistry registry) {
        if (null == crosProperties.getEnabled() || !crosProperties.getEnabled()) return;

//        //添加映射路径
        CorsRegistration registration = registry.addMapping("/**");
        //是否发送Cookie
//        registration.allowCredentials(true);
        // 域名
        registration.allowedOrigins(toArray(crosProperties.getOrigins()));
        //放行哪些请求方式
        registration.allowedMethods(toArray(crosProperties.getMethods()));
        //放行哪些原始请求头部信息
        registration.allowedHeaders("*");
        //暴露哪些原始请求头部信息
        registration.exposedHeaders(toArray(crosProperties.getExposedHeaders()));
    }

    private String[] toArray(List<String> list) {
        return list.toArray(new String[0]);
    }
}
